///////////////////////////////////////////////
//Lösung zu Aufgabe 2 im Kapitel Turtlegrafik
////////////////////////////////////////////////


// Zustand der Turtle
float actX; // aktuelle Position
float actY;
float actW; // aktueller Winkel
color actC;  // aktuelle Farbe
boolean penIsDown; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergröße
int w=1000;
int h=1000;

// Ausgangsseitenlänge des Quadats
float laenge = 1;

// Anfangsfarbe: hue ist der Farbwinkel im HSB-Farbmodell
float hue = 0;

///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() {
  colorMode(HSB,360);
  background(0,0,0);
  iniTurtle();
}

///////////////////////////////////////////////////////////

void draw() {
  // Farbe jeden Strich wechseln, sodass alle sechs Striche
  // dieselbe Farbe erscheint
  hue= (hue+60) % 360;
  setColor(color(hue,360,360));    

  // Turtle Kommandos
  turn(60.9);
  move(laenge);
  
  // Mallänge verlängern
  laenge += 1;

  // Abbruch, wenn laenge so groß wie Fensterbreite
  if (laenge == width) noLoop();
}

///////////////////////////////////////////////////////////

void keyPressed() {
  save("tmp.png");
}

///////////////////////////////////////////////////////////
//
// Turtle Kommandos
//
///////////////////////////////////////////////////////////

void iniTurtle() {
  actX=0;
  actY=0;
  actW=0;
  actC=color(0,0,0);
  penIsDown = false;
  // Hintergrund weiß im HSB Modell
  move(500);
  turn(90);
  move(500);
  turn(-90);
  penDown();
}

void move(float len) {
  // drehe die Turtle auf den aktuellen Winkel
  float dx = cos(radians(actW))*len;
  float dy = sin(radians(actW))*len;
  if (penIsDown) 
     line(actX,height-actY,actX+dx,height-(actY+dy));
  // bewege Turtle weiter
  actX+=dx;
  actY+=dy;
}

void turn(float ang) { actW += ang; }
void setColor(color c) { actC = c; stroke(actC); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }